% function [Zo_values, mpc] = Zo_calculation(mpc)
% 
% % This function allows, in relation to the calculated Zo value, to identify the corresponding line type. 
% % If the Zo value obtained does not correspond to any known line type, 
% % a warning message will be provided to warn that there may be some anomaly
% % or error.
% 
% %% define named indices into bus, gen, branch matrices
% [PQ, PV, REF, NONE, BUS_I, BUS_TYPE, PD, QD, GS, BS, BUS_AREA, VM, ...
%     VA, BASE_KV, ZONE, VMAX, VMIN, LAM_P, LAM_Q, MU_VMAX, MU_VMIN, LEAF] = id_bus;
% [F_BUS, T_BUS, BR_R, BR_X, BR_B, RATE_A, RATE_B, RATE_C, ...
%     TAP, SHIFT, BR_STATUS, PF, QF, PT, QT, MU_SF, MU_ST, ...
%     ANGMIN, ANGMAX, MU_ANGMIN, MU_ANGMAX BRIDGE, SHIFT_LIM, R, X, B, B_neg, vcc_lim, Io_lim, voltage_diff, lR, lX, lB, Zo, type, n_cond] = id_brch;
% [GEN_BUS, PG, QG, QMAX, QMIN, VG, MBASE, GEN_STATUS, PMAX, PMIN, ...
%     MU_PMAX, MU_PMIN, MU_QMAX, MU_QMIN, PC1, PC2, QC1MIN, QC1MAX, ...
%     QC2MIN, QC2MAX, RAMP_AGC, RAMP_10, RAMP_30, RAMP_Q, APF] = idx_gen;
% 
% 
% Zo_values=[Inf 250 23 Inf 55 300 Inf 290 256 28];
% l=xlsread('C:\Users\Utente\Desktop\POLI\MAGISTRALE\TESI MAGISTRALE (Colella)\materiale per scrittura codice\app aggiunta linee\Library.xlsx');
% 
% for i=1:length(mpc.branch(:,F_BUS))
%     
%     S_base=10^6.*mpc.baseMVA;
%     V_base=1000.*mpc.bus(i,BASE_KV);
%     z_base=V_base^2./S_base;
%     %Zo_values(i)= z_base.*(sqrt( mpc.branch(i,BR_X)./mpc.branch(i,BR_B))); 
%     
%     
%     if mpc.branch(i,TAP)==0 & Zo_values(i)~=Inf
%  
%         difference=abs(l(:,9)-Zo_values(i));
%         [~, idx]= min(difference);
%         mpc.branch(i,n_cond)=l(idx,3);
%         mpc.branch(i,Zo)=l(idx,8);
%         
%         if l(idx,10)== 1
%             mpc.branch(i,type)=1; %overhead lines code 1
%             
%         elseif l(idx,2)== 0
%             mpc.branch(i,type)=0; %cable lines code 0
%         end
%             
%     elseif mpc.branch(i,TAP)~=0
%         mpc.branch(i,type)=NaN;
%         mpc.branch(i,n_cond)=NaN;
%         mpc.branch(i,Zo)=NaN;
%     end
% end
% end
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 

function [Zo_values, mpc] = Zo_calculation(mpc)

% This function allows, in relation to the calculated Zo value, to identify the corresponding line type. 
% If the Zo value obtained does not correspond to any known line type, 
% a warning message will be provided to warn that there may be some anomaly
% or error.

%% define named indices into bus, gen, branch matrices
[PQ, PV, REF, NONE, BUS_I, BUS_TYPE, PD, QD, GS, BS, BUS_AREA, VM, ...
    VA, BASE_KV, ZONE, VMAX, VMIN, LAM_P, LAM_Q, MU_VMAX, MU_VMIN, LEAF] = id_bus;
[F_BUS, T_BUS, BR_R, BR_X, BR_B, RATE_A, RATE_B, RATE_C, ...
    TAP, SHIFT, BR_STATUS, PF, QF, PT, QT, MU_SF, MU_ST, ...
    ANGMIN, ANGMAX, MU_ANGMIN, MU_ANGMAX BRIDGE, SHIFT_LIM, R, X, B, B_neg, vcc_lim, Io_lim, voltage_diff, lR, lX, lB, Zo, type, n_cond] = id_brch;
[GEN_BUS, PG, QG, QMAX, QMIN, VG, MBASE, GEN_STATUS, PMAX, PMIN, ...
    MU_PMAX, MU_PMIN, MU_QMAX, MU_QMIN, PC1, PC2, QC1MIN, QC1MAX, ...
    QC2MIN, QC2MAX, RAMP_AGC, RAMP_10, RAMP_30, RAMP_Q, APF] = idx_gen;


 Zo_values=[Inf 250 23 Inf 55 300 Inf 290 256 28];% mettendo questi
%valori casuali la funzione fornisce i risultati corretti ma i valori che ottengo con la
%linea 23 Zo_values= z_base.*(sqrt( mpc.branch(i,BR_X)./mpc.branch(i,BR_B)))  non son corretti

for i=1:length(mpc.branch(:,F_BUS))
    
    S_base=10^6.*mpc.baseMVA;
    V_base=1000.*mpc.bus(i,BASE_KV);
    z_base=V_base^2./S_base;
    %Zo_values(i)= z_base.*(sqrt( mpc.branch(i,BR_X)./mpc.branch(i,BR_B))); %questa formula giusta
    
    
    %Zo_values(i)= z_base.*(sqrt(sqrt( mpc.branch(i,BR_X).^2.+mpc.branch(i,BR_R).^2)./mpc.branch(i,BR_B)));
    
    if mpc.branch(i,TAP)==0
        if mpc.bus(i,BASE_KV)>340 & mpc.bus(i,BASE_KV)<450
            if Zo_values(i)>10 & Zo_values(i)<100
                mpc.branch(i,type)=1;% 1 means cable lines 0 overhead lines
                mpc.branch(i,n_cond)=1;
                mpc.branch(i,Zo)=1; % type 1: 400 kV CL 1 cond for phase
            end
            if Zo_values(i)>230 & Zo_values(i)<280
                mpc.branch(i,type)=0;
                mpc.branch(i,n_cond)=3;
                mpc.branch(i,Zo)=2; % type 2: 400 kV OL 3 cond for phase
            end
            if Zo_values(i)>280 & Zo_values(i)<320
                mpc.branch(i,type)=0;
                mpc.branch(i,n_cond)=2;
                mpc.branch(i,Zo)=3; % type 3: 400 kV OL 2 cond for phase
            end
        end
        
        if mpc.bus(i,BASE_KV)>180 & mpc.bus(i,BASE_KV)<260
            if Zo_values(i)>20 & Zo_values(i)<100
                mpc.branch(i,type)=1;
                mpc.branch(i,n_cond)=1;
                mpc.branch(i,Zo)=4; % type 4: 220 kV CL 1 cond for phase
            end
            if Zo_values(i)>250 & Zo_values(i)<350
                mpc.branch(:,type)=0;
                mpc.branch(:,n_cond)=2;
                mpc.branch(i,Zo)=5; % type 5: 220 kV OL 2 cond for phase
            end
            if Zo_values(i)>350 & Zo_values(i)<420
                mpc.branch(i,type)=0;
                mpc.branch(i,n_cond)=1;
                mpc.branch(i,Zo)=6; % type 6: 220 kV OL 1 cond for phase
            end
        end
    elseif mpc.branch(i,TAP)~=0
        mpc.branch(i,type)=NaN;
        mpc.branch(i,n_cond)=NaN;
        mpc.branch(i,Zo)=NaN;
    end
    unknown=(Zo_values(i)>100 & Zo_values(i)<230);
    if (Zo_values(i)>420 | unknown)& mpc.branch(i,TAP)==0
        mpc.branch(i,Zo)=NaN;
        warning('It was not possible to associate the Zo value of line (%f) to a specific type of line in the database', i);
    end
end
end