function [lines_length, mpc] = length_estimation(mpc)

% The length of the line is estimated in relation to the calculated Zo value and the hypothesized type of line.
% If the length is outside the typical range a warning message will be displayed.

%% define named indices into bus, gen, branch matrices
[PQ, PV, REF, NONE, BUS_I, BUS_TYPE, PD, QD, GS, BS, BUS_AREA, VM, ...
    VA, BASE_KV, ZONE, VMAX, VMIN, LAM_P, LAM_Q, MU_VMAX, MU_VMIN, LEAF] = id_bus;
[F_BUS, T_BUS, BR_R, BR_X, BR_B, RATE_A, RATE_B, RATE_C, ...
    TAP, SHIFT, BR_STATUS, PF, QF, PT, QT, MU_SF, MU_ST, ...
    ANGMIN, ANGMAX, MU_ANGMIN, MU_ANGMAX BRIDGE, SHIFT_LIM, R, X, B, B_neg, vcc_lim, Io_lim, voltage_diff, lR, lX, lB, Zo, type, n_cond, length] = id_brch;
[GEN_BUS, PG, QG, QMAX, QMIN, VG, MBASE, GEN_STATUS, PMAX, PMIN, ...
    MU_PMAX, MU_PMIN, MU_QMAX, MU_QMIN, PC1, PC2, QC1MIN, QC1MAX, ...
    QC2MIN, QC2MAX, RAMP_AGC, RAMP_10, RAMP_30, RAMP_Q, APF] = idx_gen;

lines_length=zeros(1,10);

l=xlsread('C:\Users\Utente\Desktop\POLI\MAGISTRALE\TESI MAGISTRALE (Colella)\materiale per scrittura codice\app aggiunta linee\Library.xlsx','E:E'); %induttanza in mH/km
x=l.*10^-3.*(2*pi*50);
Zo_values=[Inf 45 16 Inf 25 78 Inf 39 56 28]; %inserita per verificare corretto funzionamento

for i=1:max(size(mpc.branch(:,F_BUS)))
    
    S_base=10^6.*mpc.baseMVA;
    V_base=1000.*mpc.bus(i,BASE_KV);
    z_base=V_base^2./S_base;
    %Zo_values(i)= z_base.*(sqrt( mpc.branch(i,BR_X)./mpc.branch(i,BR_B)));
    
    if mpc.branch(i,Zo)==1
        lines_length(i)=Zo_values(i)/x(1); %length in km
        if (lines_length(i)<0.25 | lines_length(i)>250)
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if mpc.branch(i,Zo)==2
        lines_length(i)=Zo_values(i)/x(2); %length in km
        if lines_length(i)<0.25 | lines_length(i)>250
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if mpc.branch(i,Zo)==3
        lines_length(i)=Zo_values(i)/x(3); %length in km
        if lines_length<0.25 | lines_length>250
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if mpc.branch(i,Zo)==4
        lines_length(i)=Zo_values(i)/x(4); %length in km
        if lines_length(i)<0.25 | lines_length(i)>250
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if mpc.branch(i,Zo)==5
        lines_length(i)=Zo_values(i)/x(5); %length in km
        if lines_length(i)<0.25 | lines_length(i)>250
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if mpc.branch(i,Zo)==6
        lines_length(i)=Zo_values(i)/x(6); %length in km
        if lines_length(i)<0.25 | lines_length(i)>250
            mpc.branch(i,length)=1;
        else
            mpc.branch(i,length)=0;
        end
    end
    if isnan(mpc.branch(i,Zo)) & mpc.branch(i,TAP)==0 %
        lines_length(i)=NaN;
        mpc.branch(i,length)=1;
    end
    
    if mpc.branch(i,TAP)~=0 %
        lines_length(i)=NaN;
        mpc.branch(i,length)=NaN;
    end
    
    if lines_length(i)==0
        mpc.branch(i,length)=1;
    end
    
     if  mpc.branch(i,length)==1
        warning('The estimated length of the (%f) line is outside of a typical range of values (0.25 - 250 km)', i);
    end
end
end