function [estim_section, mpc] = section_estimation(mpc, lines_length)

% This function allows, in relation to the value of Zo and the estimate of
% the length, to estimate the section of each line.

%% define named indices into bus, gen, branch matrices
[PQ, PV, REF, NONE, BUS_I, BUS_TYPE, PD, QD, GS, BS, BUS_AREA, VM, ...
    VA, BASE_KV, ZONE, VMAX, VMIN, LAM_P, LAM_Q, MU_VMAX, MU_VMIN, LEAF] = id_bus;
[F_BUS, T_BUS, BR_R, BR_X, BR_B, RATE_A, RATE_B, RATE_C, ...
    TAP, SHIFT, BR_STATUS, PF, QF, PT, QT, MU_SF, MU_ST, ...
    ANGMIN, ANGMAX, MU_ANGMIN, MU_ANGMAX BRIDGE, SHIFT_LIM, R, X, B, B_neg, vcc_lim, Io_lim, voltage_diff, lR, lX, lB, Zo, type, n_cond, length, section] = id_brch;
[GEN_BUS, PG, QG, QMAX, QMIN, VG, MBASE, GEN_STATUS, PMAX, PMIN, ...
    MU_PMAX, MU_PMIN, MU_QMAX, MU_QMIN, PC1, PC2, QC1MIN, QC1MAX, ...
    QC2MIN, QC2MAX, RAMP_AGC, RAMP_10, RAMP_30, RAMP_Q, APF] = idx_gen;


resistivity=16.8; %nohm m
n=mpc.branch(:,n_cond);
S_base=10^6.*mpc.baseMVA;
V_base=1000.*mpc.bus(:,BASE_KV);
z_base=V_base.^2./S_base;
R=mpc.branch(:,BR_R).*z_base;
num=(lines_length.*resistivity);
den=(R.*n).';
estim_section=num./den;
mpc.branch(:,section)=estim_section;
end